=== debian/changelog ===
glfw3 (3.2-2) unstable; urgency=medium

  * Add libglfw3-wayland package using Wayland as the backend platform
    instead of X11. (Closes: #827125)

  * debian/control:
    - Demote X11 dependencies of libglfw3-dev to recommends.
    - Add manual dependency on GLX to libglfw3.
  * debian/rules:
    - Use -Wl,--as-needed to prevent libwayland-server dependency.
  * debian/*.symbols:
    - Add Build-Depends-Package line to symbols files.
  * debian/tests:
   - Run autopkgtests on X11 and Wayland backends.

 -- James Cowgill <jcowgill@debian.org>  Wed, 22 Jun 2016 11:56:23 +0100

glfw3 (3.2-1) unstable; urgency=medium

  * New upstream version.

  * debian/control:
    - Build-depend on libvulkan-dev.
    - Drop dependencies on libxi-dev.
  * debian/copyright:
    - Update for 3.2.
  * debian/libglfw3.symbols:
    - Add symbols added in 3.2.
  * debian/patches:
    - Drop cmake-config-fixes.patch -- applied upstream.
  * debian/tests:
    - Fix autopkgtests not working for non-patch versions of glfw.
    - Use the new glfw CMake import target in autopkgtest.

 -- James Cowgill <jcowgill@debian.org>  Fri, 03 Jun 2016 12:36:45 +0100

glfw3 (3.1.2-4) unstable; urgency=medium

  * debian/control:
   - Move doxygen to Build-Depends-Indep. (Closes: #825492)
   - Drop libglu-dev dependency from libglfw3-dev.
   - Switch to my debian.org email address.
   - Bump standards version (no changes).
  * debian/rules:
   - Enable all hardening options.

 -- James Cowgill <jcowgill@debian.org>  Fri, 27 May 2016 12:51:15 +0100
