=== debian/control ===
Source: glfw3
Section: libs
Priority: optional
Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
Uploaders: Mahyuddin Susanto <udienz@ubuntu.com>,
           Roman Valov <roman.valov@gmail.com>,
           James Cowgill <jcowgill@debian.org>
Build-Depends:
 cmake,
 debhelper (>= 9),
 dh-exec,
 extra-cmake-modules,
 libegl1-mesa-dev,
 libgl1-mesa-dev | libgl-dev,
 libvulkan-dev,
 libwayland-dev,
 libx11-dev,
 libxcursor-dev,
 libxinerama-dev,
 libxkbcommon-dev,
 libxrandr-dev,
 libxxf86vm-dev,
 pkg-config,
 wayland-protocols,
Build-Depends-Indep: doxygen
Standards-Version: 3.9.8
Homepage: http://www.glfw.org/
Vcs-Git: https://anonscm.debian.org/git/pkg-games/glfw3.git
Vcs-Browser: https://anonscm.debian.org/cgit/pkg-games/glfw3.git
Testsuite: autopkgtest

Package: libglfw3
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends:
 libgl1-mesa-glx | libgl1,
 ${shlibs:Depends},
 ${misc:Depends},
Suggests:
 libegl1-mesa | libegl1-x11,
 libvulkan1,
Description: portable library for OpenGL, window and input (x11 libraries)
 GLFW is an Open Source, multi-platform library for creating
 windows with OpenGL contexts and managing input and events.
 It is easy to integrate into existing applications and does
 not lay claim to the main loop.
 .
 This package provides the shared library built with the X11 backend.

Package: libglfw3-wayland
Priority: extra
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Suggests: libvulkan1
Conflicts: libglfw3
Description: portable library for OpenGL, window and input (wayland libraries)
 GLFW is an Open Source, multi-platform library for creating
 windows with OpenGL contexts and managing input and events.
 It is easy to integrate into existing applications and does
 not lay claim to the main loop.
 .
 This package provides the shared library built with the Wayland backend.

Package: libglfw3-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends:
 libglfw3 (= ${binary:Version}) | libglfw3-wayland (= ${binary:Version}),
 libgl1-mesa-dev | libgl-dev,
 ${misc:Depends},
Recommends:
 libegl1-mesa-dev,
 libvulkan-dev,
 libwayland-dev,
 libx11-dev,
 libxrandr-dev,
Conflicts: libglfw-dev
Description: portable library for OpenGL, window and input (development files)
 GLFW is an Open Source, multi-platform library for creating
 windows with OpenGL contexts and managing input and events.
 It is easy to integrate into existing applications and does
 not lay claim to the main loop.
 .
 This package provides development files.

Package: libglfw3-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}, libjs-jquery
Description: portable library for OpenGL, window and input (documentation)
 GLFW is an Open Source, multi-platform library for creating
 windows with OpenGL contexts and managing input and events.
 It is easy to integrate into existing applications and does
 not lay claim to the main loop.
 .
 This package provides documentation.
