=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

export DEB_BUILD_MAINT_OPTIONS := hardening=+all
export DEB_LDFLAGS_MAINT_APPEND := -Wl,--as-needed

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

CONFIGURE_COMMON = -DLIB_SUFFIX="/$(DEB_HOST_MULTIARCH)" \
	-DBUILD_SHARED_LIBS=ON -DGLFW_BUILD_EXAMPLES=OFF \
	-DGLFW_BUILD_TESTS=OFF

%:
	dh $@ --parallel

override_dh_auto_clean:
	dh_auto_clean -Bbuild-x11
	dh_auto_clean -Bbuild-wayland

override_dh_auto_configure:
	dh_auto_configure -Bbuild-x11 -- $(CONFIGURE_COMMON) -DGLFW_BUILD_DOCS=ON
	dh_auto_configure -Bbuild-wayland -- $(CONFIGURE_COMMON) -DGLFW_USE_WAYLAND=ON

override_dh_auto_build:
	dh_auto_build -Bbuild-x11
	dh_auto_build -Bbuild-wayland

override_dh_auto_install:
	dh_auto_install -Bbuild-x11
	dh_auto_install -Bbuild-wayland -- DESTDIR=$(CURDIR)/debian/tmp/wayland

override_dh_installexamples:
	dh_installexamples -XCMakeLists.txt
