=== debian/changelog ===
glfw3 (3.2.1-1) unstable; urgency=medium

  * New upstream version.

 -- James Cowgill <jcowgill@debian.org>  Thu, 18 Aug 2016 16:46:41 +0000

glfw3 (3.2-4) unstable; urgency=medium

  * debian/control:
    - Drop build-dependency on libvulkan-dev.
    - Add version to extra-cmake-modules build-dependency.
  * debian/rules:
    - Only build wayland package on linux.

 -- James Cowgill <jcowgill@debian.org>  Sun, 26 Jun 2016 23:56:38 +0100

glfw3 (3.2-3) unstable; urgency=medium

  * Add 02_remove-pkgconfig-requires.patch to remove the Requires.private from
    glfw3.pc. Fixes the autopkgtest failures.

 -- James Cowgill <jcowgill@debian.org>  Fri, 24 Jun 2016 22:07:57 +0100
