=== debian/control ===
--- 
+++ 
@@ -9,19 +9,18 @@
  cmake,
  debhelper (>= 9),
  dh-exec,
- extra-cmake-modules,
- libegl1-mesa-dev,
+ extra-cmake-modules (>= 1.6) [linux-any],
+ libegl1-mesa-dev [linux-any],
  libgl1-mesa-dev | libgl-dev,
- libvulkan-dev,
- libwayland-dev,
+ libwayland-dev [linux-any],
  libx11-dev,
  libxcursor-dev,
  libxinerama-dev,
  libxkbcommon-dev,
  libxrandr-dev,
  libxxf86vm-dev,
- pkg-config,
- wayland-protocols,
+ pkg-config [linux-any],
+ wayland-protocols [linux-any],
 Build-Depends-Indep: doxygen
 Standards-Version: 3.9.8
 Homepage: http://www.glfw.org/
@@ -50,7 +49,7 @@
 
 Package: libglfw3-wayland
 Priority: extra
-Architecture: any
+Architecture: linux-any
 Multi-Arch: same
 Pre-Depends: ${misc:Pre-Depends}
 Depends: ${shlibs:Depends}, ${misc:Depends}
@@ -70,7 +69,7 @@
 Multi-Arch: same
 Pre-Depends: ${misc:Pre-Depends}
 Depends:
- libglfw3 (= ${binary:Version}) | libglfw3-wayland (= ${binary:Version}),
+ libglfw3 (= ${binary:Version}) | libglfw3-wayland (= ${binary:Version}) [linux-any],
  libgl1-mesa-dev | libgl-dev,
  ${misc:Depends},
 Recommends:
