=== debian/rules ===
--- 
+++ 
@@ -10,6 +10,9 @@
 	-DBUILD_SHARED_LIBS=ON -DGLFW_BUILD_EXAMPLES=OFF \
 	-DGLFW_BUILD_TESTS=OFF
 
+# When executed, this becomes true if wayland should be skipped
+SKIP_WAYLAND := (! dh_listpackages | grep -q ^libglfw3-wayland$$)
+
 %:
 	dh $@ --parallel
 
@@ -19,15 +22,15 @@
 
 override_dh_auto_configure:
 	dh_auto_configure -Bbuild-x11 -- $(CONFIGURE_COMMON) -DGLFW_BUILD_DOCS=ON
-	dh_auto_configure -Bbuild-wayland -- $(CONFIGURE_COMMON) -DGLFW_USE_WAYLAND=ON
+	$(SKIP_WAYLAND) || dh_auto_configure -Bbuild-wayland -- $(CONFIGURE_COMMON) -DGLFW_USE_WAYLAND=ON
 
 override_dh_auto_build:
 	dh_auto_build -Bbuild-x11
-	dh_auto_build -Bbuild-wayland
+	$(SKIP_WAYLAND) || dh_auto_build -Bbuild-wayland
 
 override_dh_auto_install:
 	dh_auto_install -Bbuild-x11
-	dh_auto_install -Bbuild-wayland -- DESTDIR=$(CURDIR)/debian/tmp/wayland
+	$(SKIP_WAYLAND) || dh_auto_install -Bbuild-wayland -- DESTDIR=$(CURDIR)/debian/tmp/wayland
 
 override_dh_installexamples:
 	dh_installexamples -XCMakeLists.txt
